#pragma once

#include "BaseBuilder.h"

namespace dsp {

class OnlineBuilder : public IBaseBuilder {
public:
	OnlineBuilder(utl::SyncLog& log, utl::SyncOptional<std::wstring>& text)
		: IBaseBuilder(log, text)
	{}
	virtual ~OnlineBuilder() {}

	virtual bool render(HWND hwnd, UINT msg, const std::wstring& path);
	virtual bool pause() { return false; }
	virtual bool togglePause() { return false; }
	virtual bool seek(LONGLONG current) { return false; }

protected:
	virtual bool onAbort(HWND hwnd, UINT msg, const std::wstring& path, LONG_PTR p1, LONG_PTR p2) { return false; }
	virtual bool onComplete(HWND hwnd, UINT msg, const std::wstring& path, LONG_PTR p1, LONG_PTR p2) { return false; }
	virtual bool onBufferEnter(HWND hwnd, UINT msg, const std::wstring& path, LONG_PTR p1, LONG_PTR p2);
	virtual bool onBufferExit(HWND hwnd, UINT msg, const std::wstring& path, LONG_PTR p1, LONG_PTR p2);
	virtual bool onEnterLoop(HWND hwnd, UINT msg, const std::wstring& path);
	virtual bool onLoop(HWND hwnd, UINT msg, const std::wstring& path);
	virtual bool onRebuild(HWND hwnd, UINT msg, const std::wstring& path);

protected:

	struct Rebuild {
		//struct Buffer {
		//	Buffer() : init(false), time(0), now(0), old(0) {}
		//	bool init;
		//	DWORD time;
		//	int now;
		//	int old;
		//};

		//struct Running {
		//	Running() : enable(true), init(false), time(0) {}
		//	bool enable;
		//	bool init;
		//	DWORD time;
		//};

		//struct Sample {
		//	Sample()
		//		: time(0)
		//		, start(0)
		//		, now(0)
		//		, old(0)
		//	{}

		//	DWORD time;
		//	LONGLONG start;
		//	LONGLONG now;
		//	LONGLONG old;
		//};

		struct Bitrate {
			Bitrate() : init(false), time(0) {}
			bool init;
			DWORD time;
		};

		//Buffer buffer;
		//Running running;
		//Sample sample;
		Bitrate bitrate;
	};

	Rebuild rebuild_;
};

} // namespace dsp
