// ResDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "ResDlg.h"
//#include "afxdialogex.h"


// CResDlg _CAO

IMPLEMENT_DYNAMIC(CResDlg, CDialog)

CResDlg::CResDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CResDlg::IDD, pParent)
	, target_(NULL)
	, align_(DT_CENTER)
{
	utl::createFont(font_);
	utl::createFont(bold_, true);

	gl_.bbs.setDatCallback([&](){
		if (IsWindow(this->GetSafeHwnd()))
		{
			this->PostMessage(WM_COMMAND, IDM_UPDATE_RES_END);
		}
	});
}

CResDlg::~CResDlg()
{
	if (font_.GetSafeHandle()) { font_.DeleteObject(); }
	if (bold_.GetSafeHandle()) { bold_.DeleteObject(); }

	gl_.bbs.setDatCallback([](){});
}

void CResDlg::SetConfig(const sl::ResConfig& cfg)
{
	res_ = cfg;
	font_.DeleteObject();
	font_.CreateFontIndirect(&res_.format.font);

	bold_.DeleteObject();
	LOGFONT copy = res_.format.font;
	copy.lfWeight = FW_BOLD;
	bold_.CreateFontIndirect(&copy);

	CWnd *wnd = GetParent();
	DestroyWindow();
	Create(IDD, wnd);

	if (!res_.back.opaque.enable)
	{
		SetLayeredWindowAttributes(0, res_.back.opaque.back, LWA_ALPHA);
	}

	OnUpdateResEnd();
}

void CResDlg::draw(CDC& dc, const CRect& org, bool mask, int text, int back)
{
	dc.SetTextColor(RGB(255, 255, 255));
	dc.SetBkColor(RGB(0, 0, 0));
	dc.SetBkMode(TRANSPARENT);

	CPoint offset(res_.back.marginX, res_.back.marginY);

	if (mask)
	{
		dc.FillRect(org, &CBrush(RGB(back, back, back)));
		layout_.mask(dc, offset, RGB(text, text, text));
	}
	else
	{
		utl::drawFrameRect(dc, org, res_.back.color);
		if (res_.box.punct)
		{
			switch (res_.format.type)
			{
			case sl::ResConfig::FROMAT_COMPACT:
			case sl::ResConfig::FROMAT_NORMAL:
				layout_.drawBox(dc, offset, 0, 0);
				layout_.drawBox(dc, offset, 1, 1);
				layout_.drawText(dc, offset);
				break;
			case sl::ResConfig::FROMAT_SIMPLE2:
			case sl::ResConfig::FROMAT_SIMPLE3:
				layout_.drawBox(dc, offset, 0, 2);
				layout_.drawBox(dc, offset, 3, 3);
				layout_.drawText(dc, offset);
				break;
			case sl::ResConfig::FROMAT_SIMPLE1:
			default:
				layout_.drawBox(dc, offset, 0, 1);
				layout_.drawBox(dc, offset, 2, 2);
				layout_.drawText(dc, offset);
				break;
			}
		}
		else
		{
			layout_.drawBox(dc, offset);
			layout_.drawText(dc, offset);
		}
	}
}


void CResDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CResDlg, CDialog)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_COMMAND(IDM_UPDATE_RES_END, &CResDlg::OnUpdateResEnd)
END_MESSAGE_MAP()


// CResDlg bZ[W nh[

BOOL CResDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	size_.SetSize(0, 0);

	if (!res_.back.opaque.enable)
	{
		SetLayeredWindowAttributes(0, res_.back.opaque.back, LWA_ALPHA);
	}

	//SetTimer(1, 100, NULL); // XVp^C}[

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CResDlg::PreTranslateMessage(MSG* pMsg)
{
	// EnterESCƏIĂ܂̂ŏԂ
    if (pMsg->message == WM_KEYDOWN &&
		(pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE))
	{
        return FALSE;
    }
	return CDialog::PreTranslateMessage(pMsg);
}


BOOL CResDlg::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
	//return CDialog::OnEraseBkgnd(pDC);
}


void CResDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ɃbZ[W nh[ R[hǉ܂B
	// `惁bZ[W CDialog::OnPaint() ĂяoȂłB

	CRect org;
	GetClientRect(&org);
	

	CDC memDC;
	memDC.CreateCompatibleDC(&dc);

	CBitmap bmp;
	bmp.CreateCompatibleBitmap(&dc, org.Width(), org.Height());

	CBitmap* oldBmp = memDC.SelectObject(&bmp);
	CFont* oldFont = memDC.SelectObject(&font_);
	////////////////////////////////////////////////////////////////////////////////////

	utl::drawFrameRect(memDC, &org, res_.back.color);

	memDC.SetTextColor(RGB(0, 0, 0));
	memDC.SetBkColor(RGB(0, 0, 0));
	memDC.SetBkMode(TRANSPARENT);

	CPoint offset(res_.back.marginX, res_.back.marginY);
	if (res_.box.punct)
	{
		switch (res_.format.type)
		{
		case sl::ResConfig::FROMAT_COMPACT:
		case sl::ResConfig::FROMAT_NORMAL:
			layout_.drawBox(memDC, offset, 0, 0);
			layout_.drawBox(memDC, offset, 1, 1);
			layout_.drawText(memDC, offset);
			break;
		case sl::ResConfig::FROMAT_SIMPLE2:
		case sl::ResConfig::FROMAT_SIMPLE3:
			layout_.drawBox(memDC, offset, 0, 2);
			layout_.drawBox(memDC, offset, 3, 3);
			layout_.drawText(memDC, offset);
			break;
		case sl::ResConfig::FROMAT_SIMPLE1:
		default:
			layout_.drawBox(memDC, offset, 0, 1);
			layout_.drawBox(memDC, offset, 2, 2);
			layout_.drawText(memDC, offset);
			break;
		}
	}
	else
	{
		layout_.drawBox(memDC, offset);
		layout_.drawText(memDC, offset);
	}
	///////////////////////////////////////////////////////////////
	dc.BitBlt(0, 0, org.Width(), org.Height(), &memDC, 0, 0, SRCCOPY);
	memDC.SelectObject(oldFont);
	memDC.SelectObject(oldBmp);
	bmp.DeleteObject();
}

void CResDlg::OnTimer(UINT_PTR nIDEvent)
{
	CDialog::OnTimer(nIDEvent);
}

void CResDlg::setAlign(DWORD align)
{
	align_ = align;
}

void CResDlg::setDat(const std::vector<bbs::ResInfo>& dat)
{
	if (dat.empty())
	{
		size_.SetSize(0, 0);
		return;
	}

	CClientDC dc(this);
	CFont* fontOld = dc.SelectObject(&font_);

	auto format = [](const std::wstring& datetime, bool second)->std::wstring{
		using namespace boost::xpressive;
		try {
			std::wstring rx = L"([0-9]+:[0-9]+)(:[0-9]+)?";
			wsmatch what;
			if (regex_search(datetime, what, wsregex::compile(rx)))
			{
				if (second)
				{
					return what[1].str() + what[2].str();
				}
				return what[1].str();
			}
		} catch (...) {}
		return std::wstring();
	};

	auto bold = [this](int index){ return res_.color.bold[index] ? &bold_ : NULL; };
	auto text = [this](int index){ return res_.color.text[index]; };
	auto link = [this](int index){ return res_.color.link[index]; };
	auto sage = [this](int index){ return res_.color.sage[index]; };

	std::wstring punct;
	switch(res_.format.punct)
	{
	case sl::ResConfig::PUNCT_NONE: break;
	case sl::ResConfig::PUNCT_SPACE: punct = L" "; break;
	case sl::ResConfig::PUNCT_COLON:
	default: punct = L" : "; break;
	}

	std::wstring noname;
	gl_.bbs.getNoName(noname);

	int space = res_.format.space;
	int width = res_.format.width;
	int marginX = res_.box.marginX;
	int marginY = res_.box.marginY;
	int punctX = res_.box.punct ? res_.box.marginX : 0;
	int punctY = res_.box.punct ? res_.box.marginY : 0;
	bool trim = false;
	
	boost::function<COLORREF(int)> color;

	layout_ = layout::GridLayout();
	for (auto it = dat.begin(); it != dat.end(); ++it)
	{
		if (it->mail.empty()) { color = text; }
		else if (it->mail == L"sage") { color = sage; }
		else { color = link; }

		switch (res_.format.type)
		{
		case sl::ResConfig::FROMAT_COMPACT:
			{
				layout::TextLayout head;
				layout::TextLayout line;
				layout::GridRow row;

				head.addX(dc, it->number + punct, color(6), bold(6));
				line.add(dc, it->message, color(5), bold(5), space, width, trim);
				row.add(head, res_.box.color, CRect(marginX, marginY, punctX, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row.add(line, res_.box.color, CRect(punctX, marginY, marginX, marginY), layout::GRID_ALIGN_LEFT_TOP, res_.box.separate);
				layout_.add(row, res_.box.space);
				break;
			}
		case sl::ResConfig::FROMAT_NORMAL:
			{
				layout::TextLayout head;
				layout::TextLayout line;
				layout::GridRow row;

				head.addX(dc, it->number + punct, color(0), bold(0));

				if (it->split.empty())
				{
					line.addX(dc, it->name + L" ", color(1), bold(1));
				}
				else
				{
					for (auto jt = it->split.begin(); jt != it->split.end(); ++jt)
					{
						line.addX(dc, jt->first, color(1), jt->second ? bold(1) : NULL);
					}
					line.addX(dc, L" ", color(1), bold(1));
				}

				line.addX(dc, L"[" + it->mail + L"] ", color(2), bold(2));
				line.addX(dc, it->datetime + L" ", color(3), bold(3));

				if (!it->id.empty())
				{
					line.addX(dc, L"ID:" + it->id, color(4), bold(4));
				}

				line.add(dc, it->message, color(5), bold(5), space, width, trim);
				row.add(head, res_.box.color, CRect(marginX, marginY, punctX, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row.add(line, res_.box.color, CRect(punctX, marginY, marginX, marginY), layout::GRID_ALIGN_LEFT_TOP, res_.box.separate);
				layout_.add(row, res_.box.space);
				break;
			}
		case sl::ResConfig::FROMAT_SIMPLE2:
		case sl::ResConfig::FROMAT_SIMPLE3:
			{
				layout::TextLayout top;
				layout::TextLayout head;
				layout::TextLayout name;
				layout::TextLayout line;
				layout::GridRow row;


				if (res_.format.type == sl::ResConfig::FROMAT_SIMPLE3 && it->name == noname)
				{
					name.addX(dc, L"", color(1), bold(1));
				}
				else if (it->split.empty())
				{
					name.addX(dc, it->name + L" ", color(1), bold(1));
				}
				else
				{
					for (auto jt = it->split.begin(); jt != it->split.end(); ++jt)
					{
						name.addX(dc, jt->first, color(1), jt->second ? bold(1) : NULL);
					}
					name.addX(dc, L" ", color(1), bold(1));
				}
				top.addX(dc, format(it->datetime, res_.format.second) + L" ", color(7), bold(7));
				head.addX(dc, it->number + punct, color(6), bold(6));
				line.add(dc, it->message, color(5), bold(5), space, width, trim);
				row.add(name, res_.box.color, CRect(marginX, marginY, 0, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row.add(top, res_.box.color, CRect(0, marginY, 0, marginY));
				row.add(head, res_.box.color, CRect(0, marginY, punctX, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row.add(line, res_.box.color, CRect(punctX, marginY, marginX, marginY), layout::GRID_ALIGN_LEFT_TOP, res_.box.separate);
				layout_.add(row, res_.box.space);
				break;
			}
		case sl::ResConfig::FROMAT_SIMPLE1:
		default:
			{
				layout::TextLayout top;
				layout::TextLayout head;
				layout::TextLayout line;
				layout::GridRow row;

				top.addX(dc, format(it->datetime, res_.format.second) + L" ", color(7), bold(7));
				head.addX(dc, it->number + punct, color(6), bold(6));
				line.add(dc, it->message, color(5), bold(5), space, width, trim);
				row.add(top, res_.box.color, CRect(marginX, marginY, 0, marginY));
				row.add(head, res_.box.color, CRect(0, marginY, punctX, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row.add(line, res_.box.color, CRect(punctX, marginY, marginX, marginY), layout::GRID_ALIGN_LEFT_TOP, res_.box.separate);
				layout_.add(row, res_.box.space);
				break;
			}
		}
	}

	CRect rc(layout_.outline());
	rc.InflateRect(res_.back.marginX, res_.back.marginY);
	size_.cx = rc.Width();
	size_.cy = rc.Height();

	if (res_.back.opaque.enable)
	{
		CRect org(0, 0, size_.cx, size_.cy);
		utl::LayeredWindow layer(size_.cx, size_.cy, font_);

		if (layer)
		{
			draw(layer.getImageCDC(), org);
			draw(layer.getMaskCDC(), org, true, res_.back.opaque.text, res_.back.opaque.back);
			if (layer.create())
			{
				layer.update(GetSafeHwnd(), dc);
			}
		}
	}

	dc.SelectObject(fontOld);
}

void CResDlg::setPosition(long x, long y, long h)
{
	// ݒuʒũj^擾
	MONITORINFO mi;
	CPoint pt(x, y);
	utl::getDesktopRectFromPoint(pt, mi);
	CRect rc(mi.rcMonitor);

	// j^[͂ݏoȂʒuvZ
	int ax = x - (size_.cx / 2), ay = y - size_.cy;

	//if (y - size_.cy < rc.top && y + h + size_.cy < rc.bottom) { ay = y + h; }

	if (x - (size_.cx / 2) < rc.left) { ax = rc.left; }// 
	else if (x + (size_.cx / 2) > rc.right) { ax = rc.right - size_.cx; }// E

	// ړ
	//MoveWindow(ax, ay, size_.cx, size_.cy);
	SetWindowPos(NULL, ax, ay, size_.cx, size_.cy, SWP_NOZORDER|SWP_NOACTIVATE);
}

void CResDlg::setPositionLeft(long x, long y, long h)
{
	// ݒuʒũj^擾
	MONITORINFO mi;
	CPoint pt(x, y);
	utl::getDesktopRectFromPoint(pt, mi);
	CRect rc(mi.rcMonitor);

	// j^[͂ݏoȂʒuvZ
	int ax = x - size_.cx, ay = y - size_.cy;

	if (x - size_.cx < rc.left) { ax = rc.left; }// 
	else if (x > rc.right) { ax = rc.right - size_.cx; }// E

	// ړ
	//MoveWindow(ax, ay, size_.cx, size_.cy);
	SetWindowPos(NULL, ax, ay, size_.cx, size_.cy, SWP_NOZORDER|SWP_NOACTIVATE);
}

void CResDlg::setPositionRight(long x, long y, long h)
{
	// ݒuʒũj^擾
	MONITORINFO mi;
	CPoint pt(x, y);
	utl::getDesktopRectFromPoint(pt, mi);
	CRect rc(mi.rcMonitor);

	// j^[͂ݏoȂʒuvZ
	int ax = x, ay = y - size_.cy;

	if (x < rc.left) { ax = rc.left; }// 
	else if (x + size_.cx > rc.right) { ax = rc.right - size_.cx; }// E

	// ړ
	//MoveWindow(ax, ay, size_.cx, size_.cy);
	SetWindowPos(NULL, ax, ay, size_.cx, size_.cy, SWP_NOZORDER|SWP_NOACTIVATE);
}

void CResDlg::setPosition()
{
	if (!target_) { return; }
	if (!target_->GetSafeHwnd()) { return; }

	CRect r;
	target_->GetWindowRect(&r);

	CPoint p;
	GetCursorPos(&p);

	switch (gl_.value.detail.board.position)
	{
	case sl::BoardConfig::POPUP_POSITION_LEFT:
		{
			setPositionLeft(p.x, r.top, r.Height());
			break;
		}
	case sl::BoardConfig::POPUP_POSITION_RIGHT:
		{
			setPositionRight(p.x, r.top, r.Height());
			break;
		}
	case sl::BoardConfig::POPUP_POSITION_BOTH:
		{
			if (p.x < r.left + (r.Width() / 2))
			{
				setPositionLeft(p.x, r.top, r.Height());
			}
			else
			{
				setPositionRight(p.x, r.top, r.Height());
			}
			break;
		}
	case sl::BoardConfig::POPUP_POSITION_CENTER:
	default:
		{
			setPosition(p.x, r.top, r.Height());
			break;
		}
	}
}

void CResDlg::showWindow(bool show)
{
	if (show)
	{
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE|SWP_NOOWNERZORDER|SWP_NOSENDCHANGING);
		ShowWindow(SW_SHOWNA);
	}
	else
	{
		// wndBottomwndTopƂ
		SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE|SWP_NOOWNERZORDER|SWP_NOSENDCHANGING);
		ShowWindow(SW_HIDE);
	}
}


void CResDlg::OnUpdateResEnd()
{
	std::vector<bbs::ResInfo> dat;
	gl_.bbs.getDat(dat);

	//std::reverse(dat.begin(), dat.end());

	setDat(dat);
	setPosition();
	Invalidate(FALSE);
}
