// ResSampleView.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "ResSampleView.h"


// CResSampleView

IMPLEMENT_DYNAMIC(CResSampleView, CSampleView)

CResSampleView::CResSampleView()
{
	::memset(&time_, 0, sizeof(SYSTEMTIME));
	::GetLocalTime(&time_);
}

CResSampleView::~CResSampleView()
{
}


BEGIN_MESSAGE_MAP(CResSampleView, CSampleView)
END_MESSAGE_MAP()



// CResSampleView bZ[W nh[

void CResSampleView::OnCustomPaint(CDC& dc, CDC& memDC, CRect& rc)
{
	CDC tmpDC;
	tmpDC.CreateCompatibleDC(&dc);

	CBitmap bmp;
	bmp.CreateCompatibleBitmap(&dc, rc.Width(), rc.Height());
	CBitmap* oldBmp = tmpDC.SelectObject(&bmp);
	//////////////////////////////////////////////////////

	// wiRs[
	tmpDC.BitBlt(0, 0, rc.Width(), rc.Height(), &memDC, 0, 0, SRCCOPY);

	std::array<std::wstring, 3> number = { L"1", L"10", L"100", };
	std::array<std::wstring, 3> message = { L"[Ȃ", L"[", L"[sage\r\n", };
	for (int i = 0; i < 3; ++i) { message.back() += L"0123456789"; }
	std::array<std::wstring, 3> mail = { L"[] ", L"[age] ", L"[sage] ", };

	auto bold = [this](int index){ return cfg_.color.bold[index] ? GetBold() : NULL; };

	std::array<boost::function<COLORREF(int)>, 3> color = {
		[this](int index){ return cfg_.color.text[index]; },
		[this](int index){ return cfg_.color.link[index]; },
		[this](int index){ return cfg_.color.sage[index]; },
	};

	std::wstring punct;
	switch(cfg_.format.punct)
	{
	case sl::ResConfig::PUNCT_NONE: break;
	case sl::ResConfig::PUNCT_SPACE: punct = L" "; break;
	case sl::ResConfig::PUNCT_COLON:
	default: punct = L" : "; break;
	}

	int space = cfg_.format.space;
	int width = cfg_.format.width;
	int marginX = cfg_.box.marginX;
	int marginY = cfg_.box.marginY;
	int punctX = cfg_.box.punct ? cfg_.box.marginX : 0;
	int punctY = cfg_.box.punct ? cfg_.box.marginY : 0;
	bool trim = false;
	
	//layout::GridLayout layout;
	layout_ = layout::GridLayout();
	switch (cfg_.format.type)
	{
	case sl::ResConfig::FROMAT_COMPACT:
		{
			std::array<layout::TextLayout, 3> head;
			std::array<layout::TextLayout, 3> line;
			std::array<layout::GridRow, 3> row;
			for (int i = 0; i < 3; ++i)
			{
				head[i].addX(memDC, number[i] + punct, color[i](6), bold(6));
				line[i].add(memDC, message[i], color[i](5), bold(5), space, width, trim);
				row[i].add(head[i], cfg_.box.color, CRect(marginX, marginY, punctX, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row[i].add(line[i], cfg_.box.color, CRect(punctX, marginY, marginX, marginY), layout::GRID_ALIGN_LEFT_TOP, cfg_.box.separate);
				layout_.add(row[i], cfg_.box.space);
			}
			break;
		}
	case sl::ResConfig::FROMAT_NORMAL:
		{
			std::wstring datetime =
				(boost::wformat(L"%04d/%02d/%02d(%s) %02d:%02d:%02d ")
					% time_.wYear %  time_.wMonth % time_.wDay % utl::convertWeek(time_.wDayOfWeek)
					% time_.wHour % time_.wMinute % time_.wSecond).str();

			std::array<layout::TextLayout, 3> head;
			std::array<layout::TextLayout, 3> line;
			std::array<layout::GridRow, 3> row;
			for (int i = 0; i < 3; ++i)
			{
				head[i].addX(memDC, number[i] + punct, color[i](0), bold(0));
				line[i].addX(memDC, L"", color[i](1), bold(1));
				line[i].addX(memDC, L"SAMPLE ", color[i](1), NULL);
				line[i].addX(memDC, mail[i], color[i](2), bold(2));
				line[i].addX(memDC, datetime, color[i](3), bold(3));
				line[i].addX(memDC, L"ID:SAMPLE", color[i](4), bold(4));
				line[i].add(memDC, message[i], color[i](5), bold(5), space, width, trim);
				row[i].add(head[i], cfg_.box.color, CRect(marginX, marginY, punctX, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row[i].add(line[i], cfg_.box.color, CRect(punctX, marginY, marginX, marginY), layout::GRID_ALIGN_LEFT_TOP, cfg_.box.separate);
				layout_.add(row[i], cfg_.box.space);
			}
			break;
		}
	case sl::ResConfig::FROMAT_SIMPLE2:
	case sl::ResConfig::FROMAT_SIMPLE3:
		{
			std::wstring datetime;
			if (cfg_.format.second)
			{
				datetime =
					(boost::wformat(L"%02d:%02d:%02d ") % time_.wHour % time_.wMinute % time_.wSecond).str();
			}
			else
			{
				datetime =
					(boost::wformat(L"%02d:%02d ") % time_.wHour % time_.wMinute).str();
			}


			std::array<layout::TextLayout, 3> top;
			std::array<layout::TextLayout, 3> head;
			std::array<layout::TextLayout, 3> name;
			std::array<layout::TextLayout, 3> line;
			std::array<layout::GridRow, 3> row;
			for (int i = 0; i < 3; ++i)
			{
				if (i != 2)
				{
					if (cfg_.format.type == sl::ResConfig::FROMAT_SIMPLE3)
					{
						name[i].addX(memDC, L"", color[i](1), bold(1));
					}
					else
					{
						name[i].addX(memDC, L" ", color[i](1), bold(1));
					}
				}
				else
				{
					name[i].addX(memDC, L"Ǘl ", color[i](1), bold(1));
				}
				top[i].addX(memDC, datetime, color[i](7), bold(7));
				head[i].addX(memDC, number[i] + punct, color[i](6), bold(6));
				line[i].add(memDC, message[i], color[i](5), bold(5), space, width, trim);
				row[i].add(name[i], cfg_.box.color, CRect(marginX, marginY, 0, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row[i].add(top[i], cfg_.box.color, CRect(0, marginY, 0, marginY));
				row[i].add(head[i], cfg_.box.color, CRect(0, marginY, punctX, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row[i].add(line[i], cfg_.box.color, CRect(punctX, marginY, marginX, marginY), layout::GRID_ALIGN_LEFT_TOP, cfg_.box.separate);
				layout_.add(row[i], cfg_.box.space);
			}
			break;
		}
	case sl::ResConfig::FROMAT_SIMPLE1:
	default:
		{
			std::wstring datetime;
			if (cfg_.format.second)
			{
				datetime =
					(boost::wformat(L"%02d:%02d:%02d ") % time_.wHour % time_.wMinute % time_.wSecond).str();
			}
			else
			{
				datetime =
					(boost::wformat(L"%02d:%02d ") % time_.wHour % time_.wMinute).str();
			}


			std::array<layout::TextLayout, 3> top;
			std::array<layout::TextLayout, 3> head;
			std::array<layout::TextLayout, 3> line;
			std::array<layout::GridRow, 3> row;
			for (int i = 0; i < 3; ++i)
			{
				top[i].addX(memDC, datetime, color[i](7), bold(7));
				head[i].addX(memDC, number[i] + punct, color[i](6), bold(6));
				line[i].add(memDC, message[i], color[i](5), bold(5), space, width, trim);
				row[i].add(top[i], cfg_.box.color, CRect(marginX, marginY, 0, marginY));
				row[i].add(head[i], cfg_.box.color, CRect(0, marginY, punctX, marginY), layout::GRID_ALIGN_TOP_RIGHT);
				row[i].add(line[i], cfg_.box.color, CRect(punctX, marginY, marginX, marginY), layout::GRID_ALIGN_LEFT_TOP, cfg_.box.separate);
				layout_.add(row[i], cfg_.box.space);
			}
			break;
		}
	}

	CRect outline(layout_.outline());
	outline.InflateRect(cfg_.back.marginX, cfg_.back.marginY);

	CRect org(rc);

	org.left = (org.Width() / 2) - (outline.Width() / 2);
	org.right = org.left + outline.Width();
	org.top = (org.Height() / 2) - (outline.Height() / 2);
	org.bottom = org.top + outline.Height();

	if (cfg_.back.opaque.enable)
	{
		utl::LayeredWindow layer(rc.Width(), rc.Height(), font_);
		if (layer)
		{
			layer.getMaskCDC().FillRect(rc, &CBrush(RGB(0, 0, 0)));
			draw(layer.getImageCDC(), org);
			draw(layer.getMaskCDC(), org, true, cfg_.back.opaque.text, cfg_.back.opaque.back);
			if (layer.create())
			{
				BLENDFUNCTION bf = { AC_SRC_OVER, 0, 255, AC_SRC_ALPHA };
				AlphaBlend(tmpDC, 0, 0, rc.Width(), rc.Height(), layer.getImageCDC(), 0, 0, rc.Width(), rc.Height(), bf);
				dc.BitBlt(0, 0, rc.Width(), rc.Height(), &tmpDC, 0, 0, SRCCOPY);
			}
		}
	}
	else
	{
		draw(memDC, org);
		BLENDFUNCTION bf = { AC_SRC_OVER, 0, (BYTE)cfg_.back.opaque.back, 0 };
		AlphaBlend(tmpDC, 0, 0, rc.Width(), rc.Height(), memDC, 0, 0, rc.Width(), rc.Height(), bf);
		dc.BitBlt(0, 0, rc.Width(), rc.Height(), &tmpDC, 0, 0, SRCCOPY);
	}
	//////////////////////////////////////////////////////
	tmpDC.SelectObject(oldBmp);
	bmp.DeleteObject();
}


void CResSampleView::draw(CDC& dc, const CRect& org, bool mask, int text, int back)
{
	dc.SetTextColor(RGB(255, 255, 255));
	dc.SetBkColor(RGB(0, 0, 0));
	dc.SetBkMode(TRANSPARENT);

	CPoint offset(org.left + cfg_.back.marginX, org.top + cfg_.back.marginY);

	if (mask)
	{
		dc.FillRect(org, &CBrush(RGB(back, back, back)));
		layout_.mask(dc, offset, RGB(text, text, text));
	}
	else
	{
		utl::drawFrameRect(dc, org, cfg_.back.color);
		if (cfg_.box.punct)
		{
			switch (cfg_.format.type)
			{
			case sl::ResConfig::FROMAT_COMPACT:
			case sl::ResConfig::FROMAT_NORMAL:
				layout_.drawBox(dc, offset, 0, 0);
				layout_.drawBox(dc, offset, 1, 1);
				layout_.drawText(dc, offset);
				break;
			case sl::ResConfig::FROMAT_SIMPLE2:
			case sl::ResConfig::FROMAT_SIMPLE3:
				layout_.drawBox(dc, offset, 0, 2);
				layout_.drawBox(dc, offset, 3, 3);
				layout_.drawText(dc, offset);
				break;
			case sl::ResConfig::FROMAT_SIMPLE1:
			default:
				layout_.drawBox(dc, offset, 0, 1);
				layout_.drawBox(dc, offset, 2, 2);
				layout_.drawText(dc, offset);
				break;
			}
		}
		else
		{
			layout_.drawBox(dc, offset);
			layout_.drawText(dc, offset);
		}
	}
}