// StatusDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "StatusDlg.h"
//#include "afxdialogex.h"


enum TIMER_ID {
	TIMER_ID_UPDATE,
	TIMER_ID_SLIDER,
};

// CStatusDlg _CAO

IMPLEMENT_DYNAMIC(CStatusDlg, CDialog)

CStatusDlg::CStatusDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStatusDlg::IDD, pParent)
	, height_(16)
	, click_(false)
	, capture_(false)
	, show_(false)
{
	utl::createFont(font_);
}

CStatusDlg::~CStatusDlg()
{
	if (font_.GetSafeHandle()) { font_.DeleteObject(); }
}

void CStatusDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


void CStatusDlg::SetConfig(const sl::StatusConfig& cfg)
{
	layout_.reset();

	cfg_ = cfg;
	font_.DeleteObject();
	font_.CreateFontIndirect(&cfg_.font);

	height_ = utl::getFontHeight(GetSafeHwnd(), font_) + (cfg_.marginY * 2);
}

void CStatusDlg::setDesc(const std::wstring& desc)
{
	desc_ = desc;
}

void CStatusDlg::clearDesc()
{
	desc_.clear();
}

BEGIN_MESSAGE_MAP(CStatusDlg, CDialog)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSELEAVE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_RBUTTONDBLCLK()
END_MESSAGE_MAP()


// CStatusDlg bZ[W nh[


BOOL CStatusDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// \ɌȂ悤ɂ
	SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOACTIVATE);

	// qg_CAO
	if (channel_.GetSafeHwnd())
	{
		channel_.DestroyWindow();
	}

	channel_.Create(CChannelDlg::IDD, this);
	channel_.SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOZORDER|SWP_NOACTIVATE);
	channel_.setAlign(DT_LEFT);

	std::wstring text;
	gl_.peca.getPanel(text);
	channel_.setText(text);

	// 
	layout_.init(gl_.value.format, [this](CRect& rc){
		reinterpret_cast<CSubpaneDlg*>(GetParent())->getVideoRect(rc);
	});

	SetTimer(TIMER_ID_UPDATE, 100, NULL); // XVp^C}[

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CStatusDlg::PreTranslateMessage(MSG* pMsg)
{
	switch (pMsg->message)
	{
	case WM_KEYDOWN:
	case WM_SYSKEYDOWN:
		return FALSE;
	}
	return CDialog::PreTranslateMessage(pMsg);
}


BOOL CStatusDlg::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
	//return CDialog::OnEraseBkgnd(pDC);
}

void CStatusDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ɃbZ[W nh[ R[hǉ܂B
	// `惁bZ[W CDialog::OnPaint() ĂяoȂłB

	CRect org;
	GetClientRect(&org);

	CDC memDC;
	memDC.CreateCompatibleDC(&dc);

	CBitmap bmp;
	bmp.CreateCompatibleBitmap(&dc, org.Width(), org.Height());
	CBitmap* oldBmp = memDC.SelectObject(&bmp);
	CFont* oldFont = memDC.SelectObject(&font_);

	///////////////////////////////////////////////////////////////
	memDC.SetTextColor(cfg_.text[0]);
	memDC.SetBkColor(RGB(0, 0, 0));
	memDC.SetBkMode(TRANSPARENT);
	
	// wi
	utl::drawStatusBar(memDC, &org, cfg_.color);

	CRect rc(org);
	// }[W
	rc.DeflateRect(cfg_.marginX, 0, cfg_.marginX, 0);

	layout_.draw(memDC, rc, desc_, nametext_);

	///////////////////////////////////////////////////////////////
	dc.BitBlt(0, 0, org.Width(), org.Height(), &memDC, 0, 0, SRCCOPY);
	memDC.SelectObject(oldFont);
	memDC.SelectObject(oldBmp);
	bmp.DeleteObject();
}



void CStatusDlg::OnTimer(UINT_PTR nIDEvent)
{
	switch (nIDEvent)
	{
	case TIMER_ID_UPDATE:
		{// XV
			if (!IsWindowVisible()) { break; }
			Invalidate(FALSE);
			break;
		}
	case TIMER_ID_SLIDER:
		{// XC_[x
			layout_.slider.enable = false;
			Invalidate(FALSE);
			KillTimer(TIMER_ID_SLIDER);
			break;
		}
	}

	CDialog::OnTimer(nIDEvent);
}


void CStatusDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	Invalidate(FALSE);
}

void CStatusDlg::SetMouseHover()
{
	// }EXĎJn(OnMouseLeave)
	TRACKMOUSEEVENT tme;
	tme.cbSize = sizeof(tme);
	tme.dwFlags = TME_LEAVE;
	tme.hwndTrack = GetSafeHwnd();
	tme.dwHoverTime = HOVER_DEFAULT;
	TrackMouseEvent(&tme);
}

void CStatusDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	CRect org;
	GetClientRect(org);

	CRect rect(org);
	rect.DeflateRect(cfg_.marginX, 0);

	if (capture_)
	{// XC_[
		// XC_[vZ
		CRect rc(rect);
		rc.left = rc.right - (layout_.volume.width + layout_.slider.width);
		rc.left += utl::StatusLayout::SLIDER_MARGIN;
		rc.right = rc.right - (layout_.volume.width + utl::StatusLayout::SLIDER_MARGIN);
		int width = rc.Width();

		// müʒu
		int pos = point.x - rc.left;
		pos = max(pos, 0);
		pos = min(pos, width);

		if (width > 0)
		{// ʓKp/~[g
			int vol = (int)(((double)pos / (double)width)*100.0);
			
			gl_.value.audio.mute = false;
			gl_.player.setMute(false);
			gl_.value.audio.volume = vol;
			gl_.player.setVolume(vol);

			Invalidate(FALSE);
			UpdateWindow();
		}
		return;
	}

	
	{// {[&XC_[
		if (layout_.volume.rect.PtInRect(point) ||
			layout_.slider.rect.PtInRect(point))
		{
			if (layout_.volume.enable)
			{// XC_[\
				KillTimer(TIMER_ID_SLIDER);// x^C}[Zbg
				layout_.slider.enable = true;
			}

			SetCursor(LoadCursor(NULL, IDC_HAND));
			channel_.ShowWindow(SW_HIDE);
			SetMouseHover();
			return;
		}
	}

	if (!gl_.value.window.status.fixed)
	{
		if (layout_.time.enable)
		{// ^C
			if (layout_.time.rect.PtInRect(point))
			{
				SetCursor(LoadCursor(NULL, IDC_HAND));
				channel_.ShowWindow(SW_HIDE);
				SetMouseHover();
				return;
			}
		}

		if (layout_.size.enable)
		{// TCY
			if (layout_.size.rect.PtInRect(point))
			{
				SetCursor(LoadCursor(NULL, IDC_HAND));
				channel_.ShowWindow(SW_HIDE);
				SetMouseHover();
				return;
			}
		}

		if (layout_.bitrate.enable)
		{// bitrate
			if (layout_.bitrate.rect.PtInRect(point))
			{
				SetCursor(LoadCursor(NULL, IDC_HAND));
				channel_.ShowWindow(SW_HIDE);
				SetMouseHover();
				return;
			}
		}

		if (layout_.fps.enable)
		{// fps
			if (layout_.fps.rect.PtInRect(point))
			{
				SetCursor(LoadCursor(NULL, IDC_HAND));
				channel_.ShowWindow(SW_HIDE);
				SetMouseHover();
				return;
			}
		}
	}

	{// `l
		if (gl_.player.peercast() && layout_.name.rect.PtInRect(point))
		{// |bvAbv\
			CRect rc(org);
			ClientToScreen(&rc);

			channel_.setPosition(rc.left, rc.top);
			channel_.Invalidate(FALSE);
			channel_.ShowWindow(SW_SHOWNA);

			SetCursor(LoadCursor(NULL, IDC_HAND));
			SetMouseHover();
			return;
		}
		else
		{
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			channel_.ShowWindow(SW_HIDE);
		}
	}

	//CDialog::OnMouseMove(nFlags, point);
}


void CStatusDlg::OnMouseLeave()
{
	SetCursor(LoadCursor(NULL, IDC_ARROW));

	if (layout_.slider.enable)
	{
		SetTimer(TIMER_ID_SLIDER, 1000, NULL);// XC_[
	}

	channel_.ShowWindow(SW_HIDE);

	CDialog::OnMouseLeave();
}


void CStatusDlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	if (gl_.player.peercast())
	{
		CRect rect;
		GetClientRect(rect);
		rect.DeflateRect(cfg_.marginX, 0);

		if (layout_.name.rect.PtInRect(point))
		{ // _uNbNŃ`lXV
			gl_.peca.info();
		}
	}

	OnLButtonDown(nFlags, point);

	//CDialog::OnLButtonDblClk(nFlags, point);
}


void CStatusDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	CRect rect;
	GetClientRect(rect);
	rect.DeflateRect(cfg_.marginX, 0);

	{// {[~[g
		if (layout_.volume.rect.PtInRect(point))
		{
			utl::toggle(gl_.value.audio.mute);
			gl_.player.setMute(gl_.value.audio.mute);
			Invalidate(FALSE);
			UpdateWindow();

			SetCursor(LoadCursor(NULL, IDC_HAND));
			click_ = true;
			return;
		}
	}

	if (!capture_)
	{// {[XC_[
		if (layout_.slider.rect.PtInRect(point))
		{
			SetCapture();
			capture_ = true;
			SetCursor(LoadCursor(NULL, IDC_HAND));
			OnMouseMove(nFlags, point); // ʏϔC
			return;
		}
	}

	{// O
		if (gl_.player.peercast() && layout_.name.rect.PtInRect(point))
		{// O͏ɃnhJ[\
			SetCursor(LoadCursor(NULL, IDC_HAND));
			click_ = true;
			return;
		}
	}


	if (!gl_.value.window.status.fixed)
	{
		if (layout_.time.enable)
		{// ^C
			if (layout_.time.rect.PtInRect(point))
			{
				if (layout_.time.type < 1) { layout_.time.type++; } else { layout_.time.type = 0; }
				gl_.value.format.time.type = layout_.time.type;
				Invalidate(FALSE);
				UpdateWindow();

				SetCursor(LoadCursor(NULL, IDC_HAND));
				click_ = true;
				return;
			}
		}

		if (layout_.size.enable)
		{// TCY
			if (layout_.size.rect.PtInRect(point))
			{
				if (layout_.size.type < 2) { layout_.size.type++; } else { layout_.size.type = 0; }
				gl_.value.format.size.type = layout_.size.type;
				Invalidate(FALSE);
				UpdateWindow();

				SetCursor(LoadCursor(NULL, IDC_HAND));
				click_ = true;
				return;
			}
		}

		if (layout_.bitrate.enable)
		{// rbg[g
			if (layout_.bitrate.rect.PtInRect(point))
			{
				if (layout_.bitrate.type < 3) { layout_.bitrate.type++; } else { layout_.bitrate.type = 0; }
				gl_.value.format.bitrate.type = layout_.bitrate.type;
				Invalidate(FALSE);
				UpdateWindow();

				SetCursor(LoadCursor(NULL, IDC_HAND));
				click_ = true;
				return;
			}
		}

		if (layout_.fps.enable)
		{// fps
			if (layout_.fps.rect.PtInRect(point))
			{
				if (layout_.fps.type < 3) { layout_.fps.type++; } else { layout_.fps.type = 0; }
				gl_.value.format.fps.type = layout_.fps.type;
				Invalidate(FALSE);
				UpdateWindow();

				SetCursor(LoadCursor(NULL, IDC_HAND));
				click_ = true;
				return;
			}
		}
	}

	// eWɕϊ
	ClientToScreen(&point);
	reinterpret_cast<CSubpaneDlg*>(GetParent())->ScreenToClient(&point);
	reinterpret_cast<CSubpaneDlg*>(GetParent())->OnLButtonDown(nFlags, point);

	//CDialog::OnLButtonDown(nFlags, point);
}



void CStatusDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (capture_)
	{
		ReleaseCapture();
		capture_ = false;
	}

	if (click_)
	{
		SetCursor(LoadCursor(NULL, IDC_HAND));
		click_ = false;
	}
	//CDialog::OnLButtonUp(nFlags, point);
}

void CStatusDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	CRect rect;
	GetClientRect(rect);
	rect.DeflateRect(cfg_.marginX, 0);

	{// {[/XC_[\؂ւ
		if ((layout_.slider.enable && layout_.slider.rect.PtInRect(point)) ||
			layout_.volume.rect.PtInRect(point))
		{
			KillTimer(TIMER_ID_SLIDER);// x^C}[Zbg

			gl_.value.format.volume.enable = utl::toggle(layout_.volume.enable);
			layout_.slider.enable = layout_.volume.enable;

			Invalidate(FALSE);
			UpdateWindow();
			SetCursor(LoadCursor(NULL, IDC_HAND));
			click_ = true;
			return;
		}
	}

	{// O
		if (gl_.player.peercast() && layout_.name.rect.PtInRect(point))
		{
			if (!gl_.value.window.status.fixed)
			{
				if (!gl_.value.window.status.channel.name)
				{
					gl_.value.window.status.channel.name = true;
				}
				else if (!gl_.value.window.status.channel.type)
				{
					gl_.value.window.status.channel.type = true;
				}
				else if (
						!gl_.value.window.status.channel.genre ||
						!gl_.value.window.status.channel.comment ||
						!gl_.value.window.status.channel.playing)
				{
					gl_.value.window.status.channel.genre = true;
					gl_.value.window.status.channel.comment = true;
					gl_.value.window.status.channel.playing = true;
				}
				else if (!gl_.value.window.status.channel.relay)
				{
					gl_.value.window.status.channel.relay = true;
				}
				else
				{
					gl_.value.window.status.channel.type = false;
					gl_.value.window.status.channel.genre = false;
					gl_.value.window.status.channel.comment = false;
					gl_.value.window.status.channel.playing = false;
					gl_.value.window.status.channel.relay = false;
				}

				gl_.createChannelInfo();
				Invalidate(FALSE);
				UpdateWindow();
			}

			// O͏ɃnhJ[\
			SetCursor(LoadCursor(NULL, IDC_HAND));
			click_ = true;
			return;
		}
	}

	if (!gl_.value.window.status.fixed)
	{
		{// ^C
			if (layout_.time.rect.PtInRect(point))
			{
				gl_.value.format.time.enable = utl::toggle(layout_.time.enable);

				Invalidate(FALSE);
				UpdateWindow();

				if (layout_.time.enable)
				{
					SetCursor(LoadCursor(NULL, IDC_HAND));
					click_ = true;
				}
				return;
			}
		}

		{// TCY
			if (layout_.size.rect.PtInRect(point))
			{
				gl_.value.format.size.enable = utl::toggle(layout_.size.enable);

				Invalidate(FALSE);
				UpdateWindow();

				if (layout_.size.enable)
				{
					SetCursor(LoadCursor(NULL, IDC_HAND));
					click_ = true;
				}
				return;
			}
		}

		{// rbg[g
			if (layout_.bitrate.rect.PtInRect(point))
			{
				gl_.value.format.bitrate.enable = utl::toggle(layout_.bitrate.enable);

				Invalidate(FALSE);
				UpdateWindow();

				if (layout_.bitrate.enable)
				{
					SetCursor(LoadCursor(NULL, IDC_HAND));
					click_ = true;
				}
				return;
			}
		}
	
		{// fps
			if (layout_.fps.rect.PtInRect(point))
			{
				gl_.value.format.fps.enable = utl::toggle(layout_.fps.enable);

				Invalidate(FALSE);
				UpdateWindow();

				if (layout_.fps.enable)
				{
					SetCursor(LoadCursor(NULL, IDC_HAND));
					click_ = true;
				}
				return;
			}
		}
	}

	//CDialog::OnRButtonDown(nFlags, point);
}


void CStatusDlg::OnRButtonUp(UINT nFlags, CPoint point)
{
	if (click_)
	{
		SetCursor(LoadCursor(NULL, IDC_HAND));
		click_ = false;
	}
	//CDialog::OnRButtonUp(nFlags, point);
}


void CStatusDlg::OnRButtonDblClk(UINT nFlags, CPoint point)
{
	OnRButtonDown(nFlags, point);

	//CDialog::OnRButtonDblClk(nFlags, point);
}

void CStatusDlg::OnMButtonDown(UINT nFlags, CPoint point)
{
	if (gl_.value.operation.mouse.status.transfer)
	{// ʏ㑀ֈϏ
		// eWɕϊ
		ClientToScreen(&point);
		reinterpret_cast<CSubpaneDlg*>(GetParent())->ScreenToClient(&point);
		reinterpret_cast<CSubpaneDlg*>(GetParent())->OnMButtonDown(nFlags, point);
		return;
	}

	CSubpaneDlg* sub = reinterpret_cast<CSubpaneDlg*>(GetParent());
	if (!sub) { return; }
	CMainDlg* main = reinterpret_cast<CMainDlg*>(sub->GetParent());
	if (!main) { return; }

	main->MouseMClickHelper(gl_.value.operation.mouse.status.mclick);

	//CDialog::OnMButtonDown(nFlags, point);
}
